//+------------------------------------------------------------------+
//|                                                  OsMA Marius.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---------------------------------------------------------------------indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  LimeGreen
#property  indicator_color2  FireBrick
#property  indicator_color3  Green
#property  indicator_color4  Red
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
//---------------------------------------------------------------------indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---------------------------------------------------------------------indicator buffers
double     OsmaBuffer[];
double     Spm;
double     Smm;
double     Spmaks1;
double     Spmaks2;
double     Smmin1;
double     Smmin2;
double     nou[];
double     ver[];
double     OsMAUP[];
double     OsMADOWN[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//--------------------------------------------------------------------2 additional buffers are used for counting.
   IndicatorBuffers(4);
//--------------------------------------------------------------------drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,OsMAUP);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,OsMADOWN);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);   
   SetIndexBuffer(2,Spmaks1);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);    
   SetIndexBuffer(3,Smmin1);
   
   SetIndexDrawBegin(0,SignalSMA);
   IndicatorDigits(Digits+2);
//-------------------------------------------------------------------name for DataWindow and indicator subwindow label
   IndicatorShortName("OsMA Marius("+FastEMA+","+SlowEMA+","+SignalSMA+")");
//-------------------------------------------------------------------initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//-------------------------------------------------------------------last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//-------------------------------------------------------------------Main Loop
   for(int i=0; i<limit; i++)
      {
         OsmaBuffer[i]=iOsMA(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_WEIGHTED,i);
         nou[i] = OsmaBuffer[i];
         ver[i] = OsmaBuffer[i+1];
         if(OsmaBuffer[i] > 0)
            {
               OsMAUP[i] = OsmaBuffer[i];
               OsMADOWN[i] = 0;
            }
            else
            {
               OsMADOWN[i] = OsmaBuffer[i];
               OsMAUP[i] = 0;
            }
//-------------------------------------------------------------------Cross Down         
         if ((nou[i]<0)&&(ver[i]>0)) 
         {
            Spmaks1 = Spmaks2;
            if(Spmaks2 > 0)
               {
                  Spmaks2 = 0;
               }
          }     
//-------------------------------------------------------------------Cross Up
         if ((nou[i]>0)&&(ver[i]<0)) 
            {
             Smmin1 = Smmin2;
              if(Smmin2 < 0)
                  {
                    Smmin2 = 0;
                  }
            }
//-------------------------------------------------------------------During Swing  
         if(ver[i] > 0)
            {
               Spm = ver[i];
               if((nou[i] > ver[i]) || (nou[i] == ver[i]))
                  {
                     Spm = nou[i];
                  }
                  if((Spm > Spmaks2) || (Spm == Spmaks2))
                     {
                        Spmaks2 = Spm;
                     }
           }
           else
           {
              Smm = ver[i];
               if((nou[i] < ver[i]) || (nou[i] == ver[i]))
                  {
                     Smm = nou[i];
                  }
                  if((Smm < Smmin2) || (Smm == Smmin2))
                     {
                         Smmin2 = Smm;
                     }
          }                    
     } 
     
//--------------------------------------------------------------------done
   return(0);
  }
//+------------------------------------------------------------------+

